var channels = new Array(
	new Channel("TVE 1", "TE1", "Nacionales"),
	new Channel("TVE 2", "TE2", "Nacionales"),
	new Channel("Antena 3", "AN3", "Nacionales"),
	new Channel("Cuatro", "CUA", "Nacionales"),
	new Channel("Tele5", "TE5", "Nacionales"),
	new Channel("La Sexta", "LA6", "Nacionales"),

	new Channel("Canal 2 Andalucía", "C2A", "Autonómicas"),
	new Channel("Canal 9", "CA9", "Autonómicas"),
	new Channel("Canal 33", "C33", "Autonómicas"),
	new Channel("Canal Sur", "CNT", "Autonómicas"),
	new Channel("ETB1", "ET1", "Autonómicas"),
	new Channel("ETB2", "ET2", "Autonómicas"),
	new Channel("Punt 2", "PU2", "Autonómicas"),
	new Channel("TeleMadrid", "MAD", "Autonómicas"),
	new Channel("TV3 Catalunya", "T3C", "Autonómicas"),
	new Channel("TVG (Galicia)", "TGA", "Autonómicas"),

	new Channel("40 Latino", "40L", "TDT"),
	new Channel("Antena.Neox", "ANX", "TDT"),
	new Channel("Antena.Nova", "ANV", "TDT"),
	new Channel("Canal 24 Horas", "C24", "TDT"),
	new Channel("Clan TV", "CLN", "TDT"),
	new Channel("CNN+", "CNP", "TDT"),
	new Channel("Disney Channel", "DCS", "TDT"),
	new Channel("FDF", "FDF", "TDT"),
	new Channel("FlyMusic", "FLY", "TDT"),
	new Channel("Net TV", "NEV", "TDT"),
	new Channel("Teledeporte", "TDS", "TDT"),
	new Channel("Veo Television", "VO1", "TDT"),
//	new Channel("Hogar 10", "H10", "TDT"), //doesn't exist
//	new Channel("SET En Veo", "V02", "TDT"), //doesn't exist
//	new Channel("Telecinco Sport", "T5S", "TDT"), //empty
//	new Channel("Tienda En Veo", "VO3", "TDT"), //doesn't exist

	new Channel("AXN", "AXN", "Otros"),
	new Channel("BBC Prime", "BBP", "Otros"),
	new Channel("BBC World", "BBW", "Otros"),
	new Channel("Canal+", "CPE", "Otros"),
	new Channel("Canal+2", "CA2", "Otros"),
	new Channel("Canal+ Accion", "CPA", "Otros"),
	new Channel("Calle 13", "C13", "Otros"),
	new Channel("CNBC", "NBC", "Otros"),
	new Channel("CNN", "CNN", "Otros"),
	new Channel("DSF", "DSF", "Otros"),
	new Channel("EuroNews", "ENW", "Otros"),
	new Channel("FOX", "FXE", "Otros"),
	new Channel("RAI 1", "RA1", "Otros"),
	new Channel("RTL Television", "RTP", "Otros"),
	new Channel("SAT 1", "ST1", "Otros"),
	new Channel("TV5 Monde Europe", "T5E", "Otros"),
	new Channel("TVE Internacional", "TVE", "Otros")
//	new Channel("Canal Hollywood", "HOL", "Otros") //empty
//	new Channel("El Canal De Historia", "HTA", "Otros"), //empty
//	new Channel("Telenovelas", "TNV", "Otros"), //empty
//	new Channel("Cosmopolitan", "CSM", "Otros"), //empty
//	new Channel("Boomerang", "BOE", "Otros"), //empty
//	new Channel("Canal+ Comedia", "CPO", "Otros"), //empty
//	new Channel("Canal+ DCine", "CPD", "Otros"), //empty
//	new Channel("Canal+ Futbol", "CFU", "Otros"), //doesn't exist
//	new Channel("Canal+ Deportes", "CDE", "Otros"), //empty
//	new Channel("Canal+ Eventos", "CEV", "Otros"), //doesn't exist
//	new Channel("Paramount Comedy", "PCC", "Otros"), //empty
//	new Channel("EuroSport", "ESP", "Otros"), //empty
//	new Channel("MTV España", "MTS", "Otros"), //empty
//	new Channel("Discovery Channel", "DSP", "Otros"), //empty
//	new Channel("Cartoon Network", "TCP", "Otros"), //empty
//	new Channel("TCM", "TNP", "Otros"), //empty
//	new Channel("Canal+ Cine 1", "CP1", "Otros"), //doesn't exist
//	new Channel("Jetix", "FOE", "Otros") //empty
//	new Channel("Sportmania", "SPM", "Otros"), //doesn't exist
//	new Channel("Documania", "DMA", "Otros"), //doesn't exist
//	new Channel("Canal+ Deportes 1", "DP1", "Otros"), //doesn't exist
//	new Channel("Cinemania", "CMN", "Otros") //doesn't exist
);

var currentDate;
var currentChannel;
var relativeDate;

function setup(){
	currentChannel = "TE1";
	currentDate = new Date();
	relativeDate = 0;
    makeSelect();
}

function onshow(){
	currentDate = new Date();
    channels[0].getShows();
	calculateAndShowThumb(document.getElementById('aqui'));
}

var shows = new Array();

var loading = "<table width='100%' height='100'><tr valign='middle'><td align='center'>Cargando...</td></tr></table>";
var nodata = "<table width='100%' height='100'><tr valign='middle'><td align='center'>No hay datos</td></tr></table>";

function startLoading(){
	document.getElementById("aqui").innerHTML = loading;
}

function Channel(name, code, group){
	var This = this;

	this.code = code;
	this.name = name;
	this.group = group;
	
	this.shows = new Array();
	
	this.dates = new Array();
	
	this.getDates = function(){
		var day = 0;
		
		for(i=0;i<this.shows.length;i++){
			if(day != this.shows[i].day){
				this.dates[this.dates.length] = new Date(this.shows[i].year,this.shows[i].month,this.shows[i].day);
			}
			day = this.shows[i].day;
		}
		
		alert(this.dates);
	}
	
	this.getShows = function(){
		
		document.getElementById("selectedC").innerHTML = this.name;
		
		var url ='http://www.showview.com/'+this.code+'.TXT';
		
		req = new XMLHttpRequest();
		req.onreadystatechange = function(){
			if (req.readyState == 4) {
				
				if (req.status == 200) {
					
					string = req.responseText;
					
					entries = new RegExp("(\\d{2})/(\\d{2})/(\\d{4}),(\\d{2}):(\\d{2}),(\\d{2}):(\\d{2}),\"(.*)\",(\\d*)", "ig");
					values = new RegExp("(\\d{2})/(\\d{2})/(\\d{4}),(\\d{2}):(\\d{2}),(\\d{2}):(\\d{2}),\"(.*)\",(\\d*)");
		
					if (string.match(entries)) {
						matches = string.match(entries);
						i=0;
						
						while(i != matches.length){
							
							if(i < (matches.length-1)){
								next = i+1;
							}else{
								next = 0;	
							}
							
							
							data = matches[i];
							
							value = data.match(values);
							
							day = value[1];
							month = value[2];
							year = value[3];
							
							hour_start = value[4];
							minute_start = value[5];
							
							hour_end = value[6];
							minute_end = value[7];
							
							title = value[8];
							
							showview = value[9];
							
							This.shows[i] = new Show(title, showview, day, month, year, hour_start, hour_end, minute_start, minute_end);
							
							i=i+1;
						}
						
					}else{
						document.getElementById("aqui").innerHTML = "error";
					}
		
					
					
				}
				
			}
		}
		
		req.open("GET", url, false);
		req.send("");
		
		populateShows();
	}
	
}

function Show(name, showview, day, month, year, hour_start, hour_end, minute_start, minute_end){
	this.name = name;
	this.showview = showview;
	this.day = day;
	this.month = month;
	this.year = year;
	this.hour_start = hour_start;
	this.hour_end = hour_end;
	this.minute_start = minute_start;
	this.minute_end = minute_end;
}

function changeChannel(code){
	startLoading();
	currentChannel = code;
	
	for(i=0;i<channels.length;i++){
		if(channels[i].code == code){
			channels[i].getShows();
		}
	}
}

function channelObj(code){
	for(i=0;i<channels.length;i++){
		if(channels[i].code == code){
			return channels[i];
		}
	}
}

function populateShows(){
	var shows = channelObj(currentChannel).shows;

	output='<table cellspacing="0" cellpadding="2" border="0">';
	output=output+"<tr";
	
	var odd = 0;
	var count = 0;
	
	for(i=0;i<shows.length;i++){
		if(shows[i].day == currentDate.getDate()){
			count++;
			output=output+"<tr";
			
			if(odd == 1){
				odd=0;
				output=output+" class='oddrow'";
			}else{
				odd=1;	
			}
			
			output=output+">";
			
			output = output+"<td class='time'>"+shows[i].hour_start+":"+shows[i].minute_start+"</td>";
			output = output+"<td>"+shows[i].name+"</td>";
			
			output = output + "</tr>";
		}
	}
	
	output = output + "</table>";
	
	if(count > 0){
		document.getElementById("aqui").innerHTML = output;
	}else{
		document.getElementById("aqui").innerHTML = nodata;
	}
	
	calculateAndShowThumb(document.getElementById('aqui'));
}

function makeSelect(){
    var buffer = "";
	var i = 0;
	
    for(i=0;i<channels.length;i++){
		
		if(i > 0){
			if(channels[i-1].group != channels[i].group){
				buffer = buffer + '<optgroup label="'+channels[i].group+'">';
			}
		}else{
			buffer = buffer + '<optgroup label="'+channels[i].group+'">';
		}
		
		
		buffer = buffer + '<option value="'+channels[i].code+'">'+channels[i].name+'</option>';
		
		
		if(i < (channels.length-1)){
			if(channels[i+1].group != channels[i].group){
				buffer = buffer + '</optgroup>';
			}
		}else{
			buffer = buffer + '</optgroup>';
		}
    }
    
    document.getElementById('selectCanal').innerHTML = buffer;
}


function zapmas(){
	var selector = document.getElementById("selectCanal");
	if(selector.selectedIndex < (selector.length-1)){
		selector.selectedIndex = selector.selectedIndex+1;
	}else{
		selector.selectedIndex = 0;
	}
	
	var newChannel = selector.options[selector.selectedIndex].value;
	changeChannel(newChannel);
}

function zapmenos(){
	var selector = document.getElementById("selectCanal");
	if(selector.selectedIndex > 0){
		selector.selectedIndex = selector.selectedIndex-1;
	}else{
		selector.selectedIndex = (selector.length-1);
	}
	
	var newChannel = selector.options[selector.selectedIndex].value;
	changeChannel(newChannel);
}

function mouseWheelMove(event) {
    var clicks = window.event.wheelDelta / 20;
    scrollBy(clicks);
	document.getElementById("aqui").innerHTML = clicks;
}

function switchRight(){
	if(relativeDate < 2){
		relativeDate = relativeDate + 1;
		displayDate();
		currentDate.setDate(currentDate.getDate()+1);
		populateShows();
	}
}

function switchLeft(){
	if(relativeDate > 0){
		relativeDate = relativeDate - 1;
		displayDate();
		currentDate.setDate(currentDate.getDate()-1);
		populateShows();
	}
}

function displayDate(){
	if(relativeDate == 0){
		document.getElementById("nav_dia").innerHTML = "Hoy";
		document.getElementById("left_arrow").src="images/left_disabled.png";
	}
	
	if(relativeDate == 1){
		document.getElementById("nav_dia").innerHTML = "Mañana";
		document.getElementById("left_arrow").src="images/left.png";
		document.getElementById("right_arrow").src="images/right.png";
	}
	
	if(relativeDate == 2){
		document.getElementById("nav_dia").innerHTML = "Pasado";
		document.getElementById("right_arrow").src="images/right_disabled.png";
	}
}


/*******************/


var lastPos;		// tracks where the last mouse position was throughout the drag

// The mouseDown function is called the user clicks on the growbox.  It prepares the
// widget to be resized and registers handlers for the resizing operations
function mouseDown(event){
	var x = event.x + window.screenX;		// the placement of the click
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);  	// begin tracking the move
	document.addEventListener("mouseup", mouseUp, true);		// and notify when the drag ends

	lastPos = {x:x, y:y};		// track where the initial mouse down was, for later comparisons
								// the mouseMove function

	event.stopPropagation();
	event.preventDefault();
}


// mouseMove performs the actual resizing of the widget.  It is called after mouseDown
// activates it and every time the mouse moves.
function mouseMove(event){
	var screenX = event.x + window.screenX;		// retrieves the current mouse position
	var screenY = event.y + window.screenY;
		
	var deltaX = 0;		// will hold the change since the last mouseMove event
	var deltaY = 0;

	if ( (window.outerWidth + (screenX - lastPos.x)) >= 336 ) { 		// sets a minimum width constraint
		deltaX = screenX - lastPos.x;								// if we're greater than the constraint,
		lastPos.x = screenX;										// save the change and update our past position
	}

	if ( (window.outerHeight + (screenY - lastPos.y)) >= 174 ) {		// setting contrains for the height
		deltaY = screenY - lastPos.y;
		lastPos.y = screenY;
	}
	//document.getElementById("selectedC").innerHTML = lastPos.x;
	window.resizeBy(deltaX, deltaY);	// resizes the widget to follow the mouse movement

	event.stopPropagation();
	event.preventDefault();
	
	calculateAndShowThumb(document.getElementById('aqui'));
}


// mouseUp is called when the user stops resizing the widget.  It removes the mouseMove and
// mouseUp event handlers, so that the widget doesn't continute resizing (because the mouse
// button is now up
function mouseUp(event){
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);	

	event.stopPropagation();
	event.preventDefault();
}

if(window.widget){
    widget.onshow = onshow;
}
